//---------------------------------------------------------------------------
//
// Name:        primjerFrm.cpp
// Author:      User
// Created:     19.12.2008 17:13:44
// Description: primjerFrm class implementation
//
//---------------------------------------------------------------------------

#include "primjerFrm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// primjerFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(primjerFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(primjerFrm::OnClose)
	EVT_BUTTON(ID_WXBUTTONCLEAR,primjerFrm::WxButtonClearClick)
	EVT_BUTTON(ID_WXBUTTONTOCKE,primjerFrm::WxButtonTockeClick)
	
	EVT_SPIN_UP(ID_WXSPINCTRLDEGREE,primjerFrm::WxSpinCtrlDegreeSpinUp)
	EVT_SPIN_DOWN(ID_WXSPINCTRLDEGREE,primjerFrm::WxSpinCtrlDegreeSpinDown)
	EVT_BUTTON(ID_WXBUTTON_BR_TOCAKA,primjerFrm::WxButton_br_tocakaClick)
END_EVENT_TABLE()
////Event Table End

primjerFrm::primjerFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
    pGLCanvas = new MyGLCanvas(GLPanel,WxPanel1, ID_GLPANEL, wxPoint(0,0), wxSize(577,577));
}

primjerFrm::~primjerFrm()
{
}

void primjerFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxPanel1 = new wxPanel(this, ID_WXPANEL1, wxPoint(0,0), wxSize(850,648));
	WxPanel1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	GLPanel = new wxPanel(WxPanel1, ID_GLPANEL, wxPoint(212,24), wxSize(577,577));
	GLPanel->Enable(false);
	GLPanel->SetBackgroundColour(*wxBLUE);
	GLPanel->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticText1 = new wxStaticText(WxPanel1, ID_WXSTATICTEXT1, wxT("Broj tocaka( <102):"), wxPoint(25,67), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxEdit_br_tocaka = new wxTextCtrl(WxPanel1, ID_WXEDIT_BR_TOCAKA, wxT(""), wxPoint(25,95), wxSize(66,19), 0, wxDefaultValidator, wxT("WxEdit_br_tocaka"));
	WxEdit_br_tocaka->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButton_br_tocaka = new wxButton(WxPanel1, ID_WXBUTTON_BR_TOCAKA, wxT("OK"), wxPoint(112,91), wxSize(35,25), 0, wxDefaultValidator, wxT("WxButton_br_tocaka"));
	WxButton_br_tocaka->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticText2 = new wxStaticText(WxPanel1, ID_WXSTATICTEXT2, wxT("Odredite tocke misem!"), wxPoint(25,158), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->Enable(false);
	WxStaticText2->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	testLabel = new wxStaticText(WxPanel1, ID_TESTLABEL, wxT("0"), wxPoint(25,486), wxDefaultSize, 0, wxT("testLabel"));
	testLabel->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxSpinCtrlDegree = new wxSpinCtrl(WxPanel1, ID_WXSPINCTRLDEGREE, wxT("2"), wxPoint(25,236), wxSize(83,24),wxSP_ARROW_KEYS, 2, 100, 2);
	WxSpinCtrlDegree->Enable(false);
	WxSpinCtrlDegree->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticText3 = new wxStaticText(WxPanel1, ID_WXSTATICTEXT3, wxT("Stupanj krivulje:"), wxPoint(25,213), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxStaticText3->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButtonTocke = new wxButton(WxPanel1, ID_WXBUTTONTOCKE, wxT("OK"), wxPoint(154,155), wxSize(35,25), 0, wxDefaultValidator, wxT("WxButtonTocke"));
	WxButtonTocke->Enable(false);
	WxButtonTocke->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticText4 = new wxStaticText(WxPanel1, ID_WXSTATICTEXT4, wxT("Koordinate:"), wxPoint(25,456), wxDefaultSize, 0, wxT("WxStaticText4"));
	WxStaticText4->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxCheckBoxRotation = new wxCheckBox(WxPanel1, ID_WXCHECKBOXROTATION, wxT("Rotacija"), wxPoint(27,389), wxSize(65,17), wxCHK_2STATE  | wxALIGN_RIGHT, wxDefaultValidator, wxT("WxCheckBoxRotation"));
	WxCheckBoxRotation->Show(false);
	WxCheckBoxRotation->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButtonClear = new wxButton(WxPanel1, ID_WXBUTTONCLEAR, wxT("Obrisi"), wxPoint(25,341), wxSize(75,25), 0, wxDefaultValidator, wxT("WxButtonClear"));
	WxButtonClear->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxCheckBoxZoom = new wxCheckBox(WxPanel1, ID_WXCHECKBOXZOOM, wxT("Zoom"), wxPoint(25,416), wxSize(65,17), wxCHK_2STATE  | wxALIGN_RIGHT, wxDefaultValidator, wxT("WxCheckBoxZoom"));
	WxCheckBoxZoom->Show(false);
	WxCheckBoxZoom->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	/* Ovaj program je rjesenje zadatka (broj 5) za kolegiji Matematicki algoritmi u geometrijskom modeliranju
	krivulja i ploha.
	
	Sluzi za interaktivno crtanje Bezierovih krivulja te dizanje stupnja iste.
	
	Autor:
	Drago Spoljaric
	*/
	WxMessageDialogAbout =  new wxMessageDialog(this, wxT("Program za interaktivno crtanje Bezierovih krivulja i dizanje stupnja istih.\n Autor: Drago poljari"), wxT("O programu"), wxOK | wxICON_INFORMATION);

	SetTitle(wxT("BezierDegreeElevation"));
	SetIcon(wxNullIcon);
	SetSize(8,8,866,684);
	Center();
	
	////GUI Items Creation End
	WxMessageDialogAbout->ShowModal();
}

void primjerFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}


/*
 * WxButton_br_tocakaClick
 */
void primjerFrm::WxButton_br_tocakaClick(wxCommandEvent& event)
{
    pGLCanvas->bezier.br_tocaka = atoi(WxEdit_br_tocaka->GetValue());
	
    int br_tocaka = atoi(WxEdit_br_tocaka->GetValue());
	wxString stupanj;
    stupanj.Printf("%d", br_tocaka-1);
	testLabel->SetLabel(stupanj);
	WxSpinCtrlDegree->SetValue(br_tocaka-1);
	WxSpinCtrlDegree->SetMin(br_tocaka-1);
	
    WxStaticText2->Enable(true);
	GLPanel->Enable(true);
	WxEdit_br_tocaka->Enable(false);
	WxButtonTocke->Enable(true);

}



/*
 * WxSpinCtrlDegreeSpinDown
 */
void primjerFrm::WxSpinCtrlDegreeSpinDown(wxSpinEvent& event )
{
	wxString stupanj;
    int deg = WxSpinCtrlDegree->GetValue();
    if(deg > WxSpinCtrlDegree->GetMin()){
        --deg;
        pGLCanvas->bezier.decreaseDegree(deg);
	   pGLCanvas->Draw();
    }
}

/*
 * WxSpinCtrlDegreeSpinUp
 */
void primjerFrm::WxSpinCtrlDegreeSpinUp(wxSpinEvent& event)
{
	wxString stupanj;
    int deg = WxSpinCtrlDegree->GetValue();
    ++deg; //moramo rucno povecati vrijednost jer GetValue() uvijek vrati za
    //jedan manje nego pise na ekrenu u WxSpinCtrl kontroli

    pGLCanvas->bezier.elevateDegree(deg);
    pGLCanvas->Draw();


}

/*
 * WxButtonTockeClick
 */
void primjerFrm::WxButtonTockeClick(wxCommandEvent& event)
{
	WxSpinCtrlDegree->Enable(true);
}



/*
 * WxButtonClearClick
 */
void primjerFrm::WxButtonClearClick(wxCommandEvent& event)
{
    pGLCanvas->Clear();
    
	WxStaticText2->Enable(false);
	GLPanel->Enable(false);
	WxEdit_br_tocaka->Enable(true);
	WxButtonTocke->Enable(false);
	WxSpinCtrlDegree->Enable(false);
}
